//
//  VisualOrders.mq4 
//  Dmitry Yakovlev 
//  dmitry_yakovlev@rambler.ru
//    WebMoney R865705290089
//------------------------------------------------------------------
#property copyright "Dmitry Yakovlev, Russia,Omsk, WM R865705290089"
#property link      "dmitry_yakovlev@rambler.ru"

#property indicator_chart_window

extern string  _ModeProf=" 0-,1-,2-";
extern int     ModeProf=0;
extern bool    levels=true;
extern string  _orders="   :";
extern string  _Type = "0 ,-1 Sell,1 Buy";
extern int     Type = 0;
extern bool    CurOrders=true;
extern int     lblSize=1;
extern bool    HistOrders=true;
extern bool    ShowProfits=false;
extern int     ShiftProfits=0;
extern bool    lShowTargets=true;
extern bool    lShowMinMax=true;
extern bool    lSummary=true;
extern int     SumCorner=1;

int      levels_period=10;
bool     at=false;
double   prev_profit=0, cur_prof5=0, prev_prof5=0;
int      wh=0;

int init()
{
   string n;
   int i,total;
   if(lblSize<1) lblSize=1;
   if(lblSize>4) lblSize=4;
   
   n=Symbol()+"_"+DoubleToStr(Period(),0)+"demo_vo";
   ObjectDelete(n);

   ObjectDelete("VisualOrders_Timer");
   DeleteSummary();
   deleteAll();
   
   for(i=0;i<=levels_period;i++)
   {
      ObjectDelete("time_day_open"+DoubleToStr(i,0));
      ObjectDelete("time_day_high"+DoubleToStr(i,0));
      ObjectDelete("time_day_high_lbl"+i);
      ObjectDelete("time_day_low"+DoubleToStr(i,0));
   }

    if(ModeProf!=0)
    {
      ObjectCreate("curtime", OBJ_LABEL,0,0,0);
      ObjectSet("curtime", OBJPROP_CORNER,0);
      ObjectSet("curtime", OBJPROP_XDISTANCE,250);
      ObjectSet("curtime", OBJPROP_YDISTANCE,0);
    }

    if(ModeProf==1)
    {
      ObjectCreate("profit2", OBJ_TEXT,0,0,0);
      ObjectCreate("Account", OBJ_TEXT,0,0,0);
    }
    else if(ModeProf==2)
    {
      ObjectCreate("Account", OBJ_LABEL,0,0,0);
      ObjectSet("Account", OBJPROP_CORNER,0);
      ObjectSet("Account", OBJPROP_XDISTANCE,250);
      ObjectSet("Account", OBJPROP_YDISTANCE,20);

      ObjectCreate("profit2", OBJ_LABEL,0,0,0);
      ObjectSet("profit2", OBJPROP_CORNER,0);
      ObjectSet("profit2", OBJPROP_XDISTANCE,320);
      ObjectSet("profit2", OBJPROP_YDISTANCE,20);
    }

   ObjectDelete("VOSignal");
   /*ObjectCreate("VOSignal", OBJ_LABEL,0,0,0);
   ObjectSet("VOSignal", OBJPROP_CORNER,1);
   ObjectSet("VOSignal", OBJPROP_XDISTANCE,10);
   ObjectSet("VOSignal", OBJPROP_YDISTANCE,10);*/
   if(lSummary) ShowSummary();
}
int deinit()
{
   string n;
   n=Symbol()+"_"+DoubleToStr(Period(),0)+"demo_vo";
   ObjectDelete(n);

   ObjectDelete("VisualOrders_Timer");
   deleteAll();
   for(int i=0;i<30;i++)
   {
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vopen"+i);
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vtake"+i);
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vstop"+i);
   }
   for(i=0;i<=levels_period;i++)
   {
      ObjectDelete("time_day_open"+DoubleToStr(i,0));
      ObjectDelete("time_day_high"+DoubleToStr(i,0));
      ObjectDelete("time_day_high_lbl"+i);
      ObjectDelete("time_day_low"+DoubleToStr(i,0));
   }
   DeleteSummary();
}

void DeleteSummary()
{
   string tmp="Sum_"+Symbol()+Period();
   ObjectDelete(tmp+"pribil");
   ObjectDelete(tmp+"ubitok");
   ObjectDelete(tmp+"itogo");
}
void ShowSummary()
{
   double pribil=0,ubitok=0,itogo=0;
   for(int i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==Symbol())
   {
      if(OrderProfit()>0) pribil+=OrderProfit();
      if(OrderProfit()<0) ubitok+=OrderProfit();
      itogo+=OrderProfit();
   }
   
   int sx=10, sy=20;
   string tmp="Sum_"+Symbol()+Period();
   
   ObjectCreate(tmp+"pribil",OBJ_LABEL,0,0,0);
   ObjectSet(tmp+"pribil", OBJPROP_CORNER,SumCorner);
   ObjectCreate(tmp+"ubitok",OBJ_LABEL,0,0,0);
   ObjectSet(tmp+"ubitok", OBJPROP_CORNER,SumCorner);
   ObjectSet(tmp+"itogo", OBJPROP_CORNER,SumCorner);
   ObjectCreate(tmp+"itogo",OBJ_LABEL,0,0,0);

   if(SumCorner==1||SumCorner==4)
   {
      ObjectSet(tmp+"pribil", OBJPROP_YDISTANCE,sy);
      ObjectSet(tmp+"ubitok", OBJPROP_YDISTANCE,sy+20);
      ObjectSet(tmp+"itogo", OBJPROP_YDISTANCE,sy+40);
   }
   if(SumCorner==3||SumCorner==2)
   {
      ObjectSet(tmp+"pribil", OBJPROP_YDISTANCE,sy+40);
      ObjectSet(tmp+"ubitok", OBJPROP_YDISTANCE,sy+20);
      ObjectSet(tmp+"itogo", OBJPROP_YDISTANCE,sy);
   }

   ObjectSet(tmp+"pribil", OBJPROP_XDISTANCE,sx);
   ObjectSetText(tmp+"pribil",": "+DoubleToStr(pribil,2), 14, "Arial", Green);

   ObjectSet(tmp+"ubitok", OBJPROP_XDISTANCE,sx);
   ObjectSetText(tmp+"ubitok",":  "+DoubleToStr(ubitok,2), 14, "Arial", Red);

   ObjectSet(tmp+"itogo", OBJPROP_XDISTANCE,sx);
   ObjectSetText(tmp+"itogo",":   "+DoubleToStr(itogo,2), 14, "Arial", Blue);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
double Trunc(double v=0)
{
   return(StrToDouble(DoubleToStr(v,0)));
}

double TakeProfit=0, StopLoss=0;

int start()
{
   datetime t1,t2,t3,t4;
   double TickValue=MarketInfo(Symbol(), MODE_TICKVALUE);
   int spread=MarketInfo(Symbol(), MODE_SPREAD);
   
   //ObjectSetText("curtime", TimeToStr(TimeCurrent(),TIME_SECONDS)+" :"+DoubleToStr(AccountLeverage(),0)+" :"+DoubleToStr(spread,0)+"  1="+DoubleToStr(TickValue,2), 12, "Arial", Lime);
   int i;
   double sell_profit=0, buy_profit=0, tot_profit=0, 
          sell_points=0, buy_points=0, tot_points=0, prev_points=0, 
          plus_profit=0, minus_profit=0;
   for(i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   {
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL) { sell_profit+=OrderProfit(); sell_points+=Ask-OrderOpenPrice();}
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) { buy_profit+=OrderProfit(); buy_points+=Bid-OrderOpenPrice();}
      
      if(OrderSymbol()==Symbol() ) 
         if(OrderProfit()>0) 
            plus_profit+=OrderProfit();
         else
            minus_profit+=OrderProfit();
   }
   tot_profit=sell_profit+buy_profit;
   tot_points=buy_points-sell_points;
   cur_prof5=Trunc(tot_points/5)*5;
   prev_prof5=Trunc(prev_points/5)*5;

   //ObjectSetText("Account", DoubleToStr(AccountEquity(),2), 12, "Arial", Lime);

   if(tot_profit>0) ObjectSetText("profit2", DoubleToStr(plus_profit,2)+"+"+DoubleToStr(minus_profit,2)+"=+"+DoubleToStr(tot_profit,2), 10, "Arial", Lime);
   else if(tot_profit<0) ObjectSetText("profit2", DoubleToStr(plus_profit,2)+""+DoubleToStr(minus_profit,2)+"="+DoubleToStr(tot_profit,2), 10, "Arial", OrangeRed);
   else if(tot_profit==0) ObjectSetText("profit2","0", 10, "Arial", Blue);
   
   // <-timer
   if(ModeProf!=0)
   {
      int tmp1=Period()*60-TimeCurrent()+Time[0];
      int tmpm=MathFloor(tmp1/60),tmps=tmp1-tmpm*60;
      string strm=DoubleToStr(tmpm,0);
      string strs=DoubleToStr(tmps,0);
      if(StringLen(strs)==1) strs="0"+strs;

      int tmp2=TimeCurrent()-Time[0];
      int tmpm2=MathFloor(tmp2/60),tmps2=tmp2-tmpm2*60;
      string strm2=DoubleToStr(tmpm2,0);
      string strs2=DoubleToStr(tmps2,0);
      if(StringLen(strs2)==1) strs2="0"+strs2;
   
      ObjectDelete("VisualOrders_Timer");
      ObjectCreate("VisualOrders_Timer", OBJ_LABEL,0,0,0);
      ObjectSet("VisualOrders_Timer", OBJPROP_CORNER,1); //0
      ObjectSet("VisualOrders_Timer", OBJPROP_XDISTANCE,50); //550
      ObjectSet("VisualOrders_Timer", OBJPROP_YDISTANCE,0);
      ObjectSetText("VisualOrders_Timer",strm2+":"+strs2+"..."+strm+":"+strs, 12, "Arial", MediumBlue);
   }
   // -timer>
   
   if(ModeProf==1)
   {
      //ObjectSet("profit2", OBJPROP_TIME1, Time[0]+Period()*60*2);
      //ObjectSet("Account", OBJPROP_TIME1, Time[0]+Period()*60*2);
      //double hh=High[iHighest(NULL,0,MODE_HIGH,5,0)], ll=Low[iLowest(NULL,0,MODE_LOW,3,0)];
      //ObjectSet("profit2", OBJPROP_PRICE1, hh+Point*9);
      //ObjectSet("Account", OBJPROP_PRICE1, hh+Point*6);
      ObjectSet("profit2", OBJPROP_TIME1, Time[0]+Period()*60*(WindowBarsPerChart()/20+2));
      ObjectSet("profit2", OBJPROP_PRICE1, Bid+Point*9);
   }

   if(levels==true)
   {
      double O=0, H=0, L=0,p_razmah=0;
      int tc1=0, tc2=0;
      string n="0";
      
      for(i=0;i<=levels_period;i++)
      {
         p_razmah=(iHigh(Symbol(),PERIOD_D1,i+1)-iLow(Symbol(),PERIOD_D1,i+1));
         n=DoubleToStr(i,0);
         O=iOpen(Symbol(),PERIOD_D1,i);
         H=iHigh(Symbol(),PERIOD_D1,i);
         L=iLow(Symbol(),PERIOD_D1,i);
         tc1=TimeCurrent()-i*24*60*60;
         tc2=TimeCurrent()-i*24*60*60+24*60*60;
         
         t1=StrToTime( DoubleToStr(TimeYear(tc1),0)+"."+DoubleToStr(TimeMonth(tc1),0)+"."+DoubleToStr(TimeDay(tc1),0) );
         t2=StrToTime( DoubleToStr(TimeYear(tc2),0)+"."+DoubleToStr(TimeMonth(tc2),0)+"."+DoubleToStr(TimeDay(tc2),0) );
         
         ObjectDelete("time_day_open"+n);
         ObjectCreate("time_day_open"+n,OBJ_TREND,0,t1,O,t2,O);
         ObjectSet("time_day_open"+n, OBJPROP_RAY, 0);
         ObjectSet("time_day_open"+n,OBJPROP_COLOR,Violet);
         ObjectSet("time_day_open"+n,OBJPROP_STYLE,STYLE_DASH);
   
         ObjectDelete("time_day_high2"+n);
         //ObjectCreate("time_day_high2"+n,OBJ_TREND,0,t1,L+p_razmah,t2,L+p_razmah);
         //ObjectSet("time_day_high2"+n, OBJPROP_RAY, 0);
         //ObjectSet("time_day_high2"+n,OBJPROP_COLOR,Lime);
         //ObjectSet("time_day_high2"+n,OBJPROP_STYLE,STYLE_SOLID);

         ObjectDelete("time_day_high"+n);
         ObjectCreate("time_day_high"+n,OBJ_TREND,0,t1,H,t2,H);
         ObjectSet("time_day_high"+n, OBJPROP_RAY, 0);
         ObjectSet("time_day_high"+n,OBJPROP_COLOR,Lime);
         ObjectSet("time_day_high"+n,OBJPROP_STYLE,STYLE_DASH);
         
         ObjectDelete("time_day_low"+n);
         ObjectCreate("time_day_low"+n,OBJ_TREND,0,t1,L,t2,L);
         ObjectSet("time_day_low"+n, OBJPROP_RAY, 0);
         ObjectSet("time_day_low"+n,OBJPROP_COLOR,Red);
         ObjectSet("time_day_low"+n,OBJPROP_STYLE,STYLE_DASH);

         ObjectDelete("time_day_low2"+n);
         //ObjectCreate("time_day_low2"+n,OBJ_TREND,0,t1,H-p_razmah,t2,H-p_razmah);
         //ObjectSet("time_day_low2"+n, OBJPROP_RAY, 0);
         //ObjectSet("time_day_low2"+n,OBJPROP_COLOR,Red);
         //ObjectSet("time_day_low2"+n,OBJPROP_STYLE,STYLE_SOLID);
         
         if(TimeDayOfWeek(t1)>=1 && TimeDayOfWeek(t1)<=5)
         {
            ObjectDelete("time_day_high_lbl"+n);
            ObjectCreate("time_day_high_lbl"+n,OBJ_TEXT,0,t1+Period()*60*(WindowBarsPerChart()/20-1),H+(WindowPriceMax()-WindowPriceMin())/30);
            ObjectSetText("time_day_high_lbl"+n, "["+DoubleToStr((H-L)/Point,0)+"]",8,"Courier New",Green);
         }

      }
   }
   
   prev_profit=tot_profit;
   prev_points=tot_points;
   
   // <---orders
      if(HistOrders==true) ShowOrders(MODE_HISTORY);
      if(CurOrders==true) ShowOrders(MODE_TRADES);
   // --- orders >
   
   // <---targets
   if(lShowTargets) fShowTargets();
   if(lSummary) ShowSummary();
   // ---targets>
   WindowRedraw();
}

void deleteAll()
{
   string tmp,prefix;
   int i,total;

   ObjectDelete("VOSignal");
   
   prefix="time_order_trades_";total=OrdersTotal();
   for(i=0;i<total+5;i++)
   {
      tmp=prefix+DoubleToStr(i,0);
      ObjectDelete(tmp);
      ObjectDelete(tmp+"O");
      ObjectDelete(tmp+"C");
      ObjectDelete(tmp+"OA");
      ObjectDelete(tmp+"CA");
      ObjectDelete(tmp+"Cprof1");
      ObjectDelete(tmp+"Cprof2");
      ObjectDelete(tmp+"max");
      ObjectDelete(tmp+"min");
   }
   prefix="time_order_hist_";total=OrdersHistoryTotal();
   for(i=0;i<total+15;i++)
   {
      tmp=prefix+DoubleToStr(i,0);
      ObjectDelete(tmp);
      ObjectDelete(tmp+"O");
      ObjectDelete(tmp+"C");
      ObjectDelete(tmp+"OA");
      ObjectDelete(tmp+"CA");
      ObjectDelete(tmp+"Cprof1");
      ObjectDelete(tmp+"Cprof2");
      ObjectDelete(tmp+"max");
      ObjectDelete(tmp+"min");
   }

   ObjectDelete("curtime");   
   ObjectDelete("profit");
   ObjectDelete("profit2");
   ObjectDelete("Account");

   ObjectDelete("time_TP");
   ObjectDelete("time_SL");
   ObjectDelete("time_mar");
   ObjectDelete("time_per");
   ObjectDelete("time_lot");
   ObjectDelete("time_lot100");
   ObjectDelete("time_vv1");
   ObjectDelete("time_vv2");
   ObjectDelete("time_sr1");
   ObjectDelete("time_sr2");
}

void ShowOrders(int mode=MODE_TRADES)
{
   int i=0; string tmp=""; color clr2=0,clr1=Blue; string prefix="time_order_trades_"; int total=0;
   double CP, pmin, pmax;
   int CT,xt,tmin,tmax;
   
   if(mode==MODE_TRADES) {prefix="time_order_trades_";total=OrdersTotal();}
   if(mode==MODE_HISTORY) {prefix="time_order_hist_";total=OrdersHistoryTotal();}
   
   //<---  
   //   
   for(i=0;i<total+15;i++)
   {
      tmp=prefix+DoubleToStr(i,0);
      ObjectDelete(tmp);
      ObjectDelete(tmp+"O");
      ObjectDelete(tmp+"C");
      ObjectDelete(tmp+"OA");
      ObjectDelete(tmp+"CA");
      ObjectDelete(tmp+"Cprof1");
      ObjectDelete(tmp+"Cprof2");
      ObjectDelete(tmp+"max");
      ObjectDelete(tmp+"min");
   }
   //  
   for(i=0;i<total;i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,mode)==true && OrderSymbol()==Symbol())
      {
         int ot=OrderType();
         if(OrderSymbol()==Symbol() && ((Type==0&&(ot==OP_BUY||ot==OP_SELL)) || (Type==1&&ot==OP_BUY) || (Type==-1&&ot==OP_SELL) ) )
         {
            tmp=prefix+DoubleToStr(i,0);
            clr2=White; if(OrderProfit()>=0) clr2=Lime; else clr2=Red;
            if(OrderType()==OP_BUY) {CP=Bid;clr1=Lime;}
            if(OrderType()==OP_SELL) {CP=Ask;clr1=Red;}
            if(mode==MODE_TRADES)  {CT=Time[0];}
            if(mode==MODE_HISTORY) {CT=OrderCloseTime();CP=OrderClosePrice();}
            
            ObjectCreate(tmp, OBJ_TREND, 0, OrderOpenTime(), OrderOpenPrice(), CT, CP);
            ObjectSet(tmp, OBJPROP_COLOR, clr2);
            ObjectSet(tmp, OBJPROP_RAY, 0);
            ObjectSet(tmp, OBJPROP_WIDTH,1);
            ObjectSet(tmp, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            
            ObjectCreate(tmp+"OA", OBJ_ARROW, 0, OrderOpenTime()/*-Period()*60*/, OrderOpenPrice());
            ObjectSet(tmp+"OA", OBJPROP_COLOR, clr1);
            ObjectSet(tmp+"OA", OBJPROP_ARROWCODE, 1);
            
            /*if(mode==MODE_TRADES) 
            {
               ObjectCreate(tmp+"O", OBJ_ARROW, 0, OrderOpenTime()-Period()*60, OrderOpenPrice());
               ObjectSet(tmp+"O", OBJPROP_COLOR, clr1);
               ObjectSet(tmp+"O", OBJPROP_WIDTH, lblSize);
               ObjectSet(tmp+"O", OBJPROP_ARROWCODE, 5);
            }*/

            if(mode==MODE_HISTORY && ShowProfits)
            {
               int j=0, sh=iBarShift(Symbol(),0,CT,true);
               double pr=0;
               
               if(ShiftProfits>=0) for(j=4;j>=0;j--) pr=MathMax(pr,iHigh(Symbol(),0,sh+j));
               if(ShiftProfits<0) for(j=4;j>=0;j--) pr=MathMax(pr,iLow(Symbol(),0,sh+j));
               
               if(ShiftProfits!=0)
                  ObjectCreate(tmp+"Cprof2", OBJ_TEXT, 0, CT, pr+ShiftProfits*Point);

               if(ShiftProfits==0)
                  ObjectCreate(tmp+"Cprof2", OBJ_TEXT, 0, CT, pr+(WindowPriceMax()-WindowPriceMin())/10);

               string sss=""; color clrProf=Lime;
               if(OrderProfit()>0) { sss="+"; clrProf=Lime;}
               if(OrderProfit()<0) { sss="-"; clrProf=Red;}
               
               ObjectSetText(tmp+"Cprof2", sss+DoubleToStr(MathAbs(OrderClosePrice()-OrderOpenPrice())/Point,0)+"("+DoubleToStr(MathAbs(OrderProfit()),0)+"$)",10,"Arial",clrProf);
               ObjectSet(tmp+"Cprof2", OBJPROP_ANGLE,90);
            }
            ObjectCreate(tmp+"CA", OBJ_ARROW, 0, CT/*+Period()*60*/, CP);
            ObjectSet(tmp+"CA", OBJPROP_COLOR, clr2);
            ObjectSet(tmp+"CA", OBJPROP_ARROWCODE, 3);
            
            // <-max/min
            
            if(lShowMinMax==true)
            {
               xt=0; pmin=1000;pmax=-1000; tmin=OrderOpenTime(); tmax=OrderOpenTime();
               for(xt=iBarShift(Symbol(),0,OrderOpenTime(),true);xt>=iBarShift(Symbol(),0,CT,true);xt--)
               {
                  if(pmin>Low[xt])
                  {
                     pmin=Low[xt];
                     tmin=xt;
                  }
                  if(pmax<High[xt])
                  {
                     pmax=High[xt];
                     tmax=xt;
                  }
               }
               ObjectCreate(tmp+"max", OBJ_TEXT, 0, Time[tmax], pmax+(WindowPriceMax()-WindowPriceMin())/30);
               ObjectSetText(tmp+"max", DoubleToStr((pmax-OrderOpenPrice())/Point,0),8,"Arial",Yellow);
               ObjectSet(tmp+"max", OBJPROP_ANGLE,90);
               if(OrderType()==OP_SELL) ObjectSet(tmp+"max", OBJPROP_COLOR,Red);
               if(OrderType()==OP_BUY) ObjectSet(tmp+"max", OBJPROP_COLOR,Lime);


               ObjectCreate(tmp+"min", OBJ_TEXT, 0, Time[tmin], pmin-(WindowPriceMax()-WindowPriceMin())/30);
               ObjectSetText(tmp+"min", DoubleToStr((OrderOpenPrice()-pmin)/Point,0),8,"Arial",Yellow);
               ObjectSet(tmp+"min", OBJPROP_ANGLE,90);
               if(OrderType()==OP_SELL) ObjectSet(tmp+"min", OBJPROP_COLOR,Lime);
               if(OrderType()==OP_BUY) ObjectSet(tmp+"min", OBJPROP_COLOR,Red);
            }            
            // max/min->
         }
      }
   }
   //--- >
}


void fShowTargets()
{
   int      i=0, prof_pts=0, ticket=0; 
   double   dist_stop_pts, dist_stop;
   double   dist_take_pts, dist_take;
   double   pr=(Ask+Bid)/2, prof=0;
   datetime CT=Time[0]+Period()*60*(WindowBarsPerChart()/20+2); // time shift
   double   CP=5*Point; // price shift
   int      FS=10; // font size
   color    prof_clr=Blue;
   string   txt="";
   //-------------------------------------------------------------
   for(i=0;i<10;i++)
   {
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vopen"+i);
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vtake"+i);
      ObjectDelete(Symbol()+DoubleToStr(Period(),0)+"vstop"+i);
   }
   for(i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   {
      // <---
      RefreshRates();
      prof=OrderProfit();
      if(OrderType()==OP_BUY || OrderType()==3 || OrderType()==4) 
      {
         pr=Bid;
         prof_pts=MathRound(NormalizeDouble(pr,Digits)/Point)-MathRound(NormalizeDouble(OrderOpenPrice(),Digits)/Point);
      }
      if(OrderType()==OP_SELL || OrderType()==2 || OrderType()==5)
      {
         pr=Ask;
         prof_pts=-(MathRound(NormalizeDouble(pr,Digits)/Point)-MathRound(NormalizeDouble(OrderOpenPrice(),Digits)/Point));
      }
      prof_clr=Blue;
      if(prof_pts<0) prof_clr=Red;
      if(prof_pts>0) prof_clr=Green;
      txt="";
      if(OrderType()==0 || OrderType()==1) txt=" ("+DoubleToStr(MathAbs(prof),2)+"$)";
      ObjectCreate(Symbol()+DoubleToStr(Period(),0)+"vopen"+i,OBJ_TEXT,0,CT,OrderOpenPrice()+CP);
      ObjectSetText(Symbol()+DoubleToStr(Period(),0)+"vopen"+i,DoubleToStr(MathAbs(prof_pts),0)+txt,FS,"Arial",prof_clr);

      dist_take_pts=0;dist_take=0;
      if(OrderTakeProfit()!=0) 
      {
         dist_take_pts=MathAbs(pr/Point-OrderTakeProfit()/Point);
         txt=DoubleToStr(dist_take_pts,0);
         dist_take_pts=MathAbs(OrderOpenPrice()/Point-OrderTakeProfit()/Point);
         txt=txt+"("+DoubleToStr(dist_take_pts,0)+"/"+DoubleToStr(dist_take_pts*OrderLots()*MarketInfo(Symbol(), MODE_TICKVALUE),2)+"$)";
         
         ObjectCreate(Symbol()+DoubleToStr(Period(),0)+"vtake"+i,OBJ_TEXT,0,CT,OrderTakeProfit()+CP);
         ObjectSetText(Symbol()+DoubleToStr(Period(),0)+"vtake"+i,txt,FS,"Arial",Green);
      }
      
      dist_stop_pts=0;dist_stop=0;
      if(OrderStopLoss()!=0)
      {
         if(OrderType()==OP_BUY || OrderType()==3 || OrderType()==4)  pr=Ask;
         if(OrderType()==OP_SELL || OrderType()==2 || OrderType()==5) pr=Bid;
         dist_stop_pts=MathAbs(pr/Point-OrderStopLoss()/Point);
         txt=DoubleToStr(dist_stop_pts,0);
         dist_stop_pts=MathAbs(OrderOpenPrice()/Point-OrderStopLoss()/Point);
         txt=txt+"("+DoubleToStr(dist_stop_pts,0)+"/"+DoubleToStr(dist_stop_pts*OrderLots()*MarketInfo(Symbol(), MODE_TICKVALUE),2)+"$)";

         ObjectCreate(Symbol()+DoubleToStr(Period(),0)+"vstop"+i,OBJ_TEXT,0,CT,OrderStopLoss()+CP);
         ObjectSetText(Symbol()+DoubleToStr(Period(),0)+"vstop"+i,txt,FS,"Arial",Red);
      }
      // --->
   }
}


